from simtools.AssetManager.AssetFile import AssetFile
from simtools.Services.WorkItem.WorkItemSvc import ObjectDataStore
from simtools.Services.Utility.WorkItemHelper_temp import get_wi_by_id
from simtools.Utilities.COMPSUtilities import COMPS_login

from COMPS.Data.WorkItem import WorkItem
from COMPS.Data.WorkItem import WorkerOrPluginKey


def query_item():
    endpoint = 'https://comps2.idmod.org'
    COMPS_login(endpoint)
    item_id = '2b30f908-efaa-e811-80c9-f0921c167864'
    item_id = '6dbf8938-01ab-e811-80c9-f0921c167864'
    item_id = 'faa2f22d-bcab-e811-80c9-f0921c167864'
    item = get_wi_by_id(item_id)
    print(item)

    if item:
        print(dir(item))
        print(item.__dict__)

"""
{
    "id": "faa2f22d-bcab-e811-80c9-f0921c167864",
    "name": "Guyana Input Data Request (3ab0ef87) MergeNodesWorker",
    "worker": {
        "name": "MergeNodesWorker",
        "version": "1.0.0.0_RELEASE"
    },
    "environment_name": "Bayesian",
    "owner": "mafisher",
    "date_created": "2018-08-29 18:48:59.050000+00:00",
    "last_modified": "2018-08-29 18:49:32.337000+00:00",
    "state": "Succeeded",
    "host_name": "IDMSPAPP04",
    "worker_instance_id": "5a7344b7-8249-4ea6-a2ab-aa66c1c890e4"
}
['_SerializableEntity__convert_regex', '_SerializableEntity__ignore_unknowns', '_SerializableEntity__prop_ignore_map', '_SerializableEntity__prop_strs_map', '_SerializableEntity__py2rest_property_map', '_SerializableEntity__rest2py_property_map', '_SerializableEntity__tmp_ignore_props', '_SerializableEntity__tmp_prop_name_strs', '_SerializableEntity__tmp_prop_rename_strs', '_WorkItem__estimate_workitem_size', '_WorkItem__max_entity_retrieval_count', '_WorkItem__max_wi_batch_count', '_WorkItem__max_wi_batch_request_size_kb', '_WorkItem__prep_wi', '_WorkItem__save_batch', '_WorkItem__save_semaphore', '_WorkItem__tls', '__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__internal_factory__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_add_prop_name', '_add_prop_rename', '_date_created', '_description', '_environment_name', '_error_message', '_files', '_get_dirty_list', '_get_related_entities', '_host_name', '_id', '_is_dirty', '_last_modified', '_map_properties', '_name', '_owner', '_pascal_to_snake_case', '_plugins', '_priority', '_register_change', '_save_tags', '_set_ignore_props', '_set_state', '_snake_to_pascal_case', '_state', '_tags', '_tmp_file_parts', '_worker', '_worker_instance_id', 'add_file', 'add_work_order', 'cancel', 'commission', 'convertToDict', 'date_created', 'delete', 'delete_tags', 'description', 'environment_name', 'error_message', 'files', 'get', 'get_related_asset_collections', 'get_related_experiments', 'get_related_simulations', 'get_related_suites', 'get_related_work_items', 'get_save_semaphore', 'host_name', 'id', 'last_modified', 'merge_tags', 'name', 'owner', 'plugins', 'priority', 'py2rest', 'refresh', 'rest2py', 'save', 'save_all', 'set_tags', 'state', 'tags', 'worker', 'worker_instance_id']
{'_id': UUID('faa2f22d-bcab-e811-80c9-f0921c167864'), '_name': 'Guyana Input Data Request (3ab0ef87) MergeNodesWorker', '_worker': WorkerOrPluginKey(name='MergeNodesWorker', version='1.0.0.0_RELEASE'), '_environment_name': 'Bayesian', '_description': None, '_owner': 'mafisher', '_date_created': datetime.datetime(2018, 8, 29, 18, 48, 59, 50000, tzinfo=<UTC>), '_last_modified': datetime.datetime(2018, 8, 29, 18, 49, 32, 337000, tzinfo=<UTC>), '_state': <WorkItemState.Succeeded: 130>, '_error_message': None, '_host_name': 'IDMSPAPP04', '_worker_instance_id': UUID('5a7344b7-8249-4ea6-a2ab-aa66c1c890e4'), '_priority': None, '_tags': None, '_files': None, '_plugins': None, '_is_dirty': False, '_tmp_file_parts': []}

"""


def test_sharon():
    from simtools.Utilities.COMPSUtilities import get_simulation_by_id
    # id = 'aa8dc94e-b486-e811-80c9-f0921c167864'
    id = 'aa86e610-3786-e811-80c9-f0921c167864'
    id = '1c310c7f-ba86-e811-80c9-f0921c167864'
    sim = get_simulation_by_id(id)
    print(sim)


    f = sim.retrieve_output_files(['output/insetchart.json'])
    print(f)


def test_sharon2():
    from simtools.Utilities.COMPSUtilities import get_simulation_by_id
    # id = 'aa8dc94e-b486-e811-80c9-f0921c167864'
    id = 'aa86e610-3786-e811-80c9-f0921c167864'
    id = '1c310c7f-ba86-e811-80c9-f0921c167864'
    sim = get_simulation_by_id(id)
    print(sim)

    metadata = sim.retrieve_output_file_info([])
    print(metadata)

    for i in list(metadata):
        print(i.path_from_root)


def test_create_item_object():
    kwargs = {"type": "WI", "provider": "COMPS", "item_id": "123"}
    item = ObjectDataStore.create_item_object(**kwargs)
    return item


def test_create_item():
    kwargs = {"type": "WI", "provider": "COMPS", "item_id": "faa2f22d-bcab-e811-80c9-f0921c167864"}
    ObjectDataStore.create_item(**kwargs)


def test_update_item():
    pass


def test_get_item():
    item = ObjectDataStore.get_item(123)
    print(item)

    # item.provider = "AZURE"
    # ObjectDataStore.save_item(item)
    #
    # item = ObjectDataStore.get_item(1)
    # print(item)


def test_delete_item():
    ObjectDataStore.delete_item(1)
    item = ObjectDataStore.get_item(1)
    print(item)


def test_create_wi():
    compshost = 'https://comps-dev.idmod.org'
    compsenv = 'Bayesian'

    # login is required in order to create a WorkItem
    # Client.login(compshost)

    wi = WorkItem(name='Test DockerWorker WorkItem',
                  worker=WorkerOrPluginKey('DockerWorker', '1.0.0.0_RELEASE'),
                  environment_name=compsenv,
                  description='pyComps: Docker work item.')

    print(wi)


def test_AssetFile():
    af = AssetFile('test', 'WorkItemManager.py')
    print(af)


if __name__ == "__main__":
    test_AssetFile()
    exit()


    test_create_wi()
    exit()

    query_item()
    exit()

    item = test_create_item_object()
    print(item)
    exit()

    test_create_item()
    exit()

    test_get_item()
    exit()

    test_delete_item()
    exit()
