import json
from simtools.Analysis.BaseAnalyzers.BaseAnalyzer import BaseAnalyzer
from simtools.Analysis.AnalyzeManager import AnalyzeManager


class MyAnalyzer(BaseAnalyzer):

    def __init__(self):
        super().__init__(filenames=["output\\InsetChart.json"])

    def select_simulation_data(self, data, simulation):
        return simulation.id

    def finalize(self, all_data):
        with open("results.json", "w") as fp:
            json.dump({s.id:v for s,v in all_data.items()}, fp)

    # def select_simulation_data(self, data, simulation):
    #     return data[self.filenames[0]]["Channels"]["Statistical Population"]

    # def select_simulation_data(self, data, simulation):
    #     return data[self.filenames[0]]["Channels"]["Adult Vectors"]["Data"]

    # def finalize(self, all_data):
    #     with open("results.json", "w") as fp:
    #         json.dump(all_data, fp)


if __name__ == "__main__":
    am = AnalyzeManager(exp_list=["dea2b957-5ba5-e811-80c9-f0921c167864"], analyzers=[MyAnalyzer()])
    am.analyze()
