import time
from COMPS import Client
from COMPS.Data.WorkItem import WorkItemState

from simtools.Services.ObjectInfo.ObjectInfoSvc import ObjectInfoSvc
from simtools.Services.Samples.more.WorkItemManager import WorkItemManager
from simtools.SetupParser import SetupParser
from simtools.Services.WorkItem.WorkItemSvc import WorkItemSvc
from simtools.Services.WorkItem.WorkOrder import WorkOrder
from simtools.Services.Status.StatusSvc import StatusSvc

# note: SetupParser internal calling COMPS login
# SetupParser.default_block = 'HPC'
# SetupParser.init()

# compshost = SetupParser.get('server_endpoint')
# Client.login(compshost)


def test_status():

    item_id = "285545fe-bcb2-e811-80c9-f0921c167864"

    # check status
    state = StatusSvc.get_status(item_id)
    print(state)

    # check item info
    details = StatusSvc.get_details(item_id)
    print(details)


def test_status_2():

    # comps-dev work item
    item_id = "72078a86-3cb8-e811-80c9-f0921c167864"

    ep = ObjectInfoSvc.get_item_endpoint(item_id)
    print(ep)

    info = ObjectInfoSvc.get_item_info(item_id)
    print(info)

    endpoint = info["provider_info"]["endpoint"]
    print(endpoint)

    endpoint = 'https://comps-dev.idmod.org'
    Client.login(endpoint)

    # check status
    state = StatusSvc.get_status(item_id)
    print(state)

    # check item info
    details = StatusSvc.get_details(item_id)
    print(details)


def test_status_3():

    # comps2 work item
    item_id = "3d9313fc-20b8-e811-80c9-f0921c167864"

    info = ObjectInfoSvc.get_item_info(item_id)
    print(info)

    endpoint = info["provider_info"]["endpoint"]
    print(endpoint)


    # note: here we need to know which environment the item seat in: say, COMPS2 or comps-dev
    # once we get this info, we need to login to that environment first

    # endpoint = 'https://comps2.idmod.org'
    Client.login(endpoint)

    # check status: item_id is not in local object db
    # state = StatusSvc.get_status(item_id)
    # print(state)

    # check status: by pass local object db
    state = WorkItemSvc.get_item_status(item_id)
    print(state)

    # check item info
    details = WorkItemSvc.get_item_details(item_id)
    print(details)


def test_create_item():
    # provider_info = {"endpoint": "https://comps-dev.idmod.org", "environment": "Bayesian"}
    # ObjectInfoSvc.create_item(type='MI', provider='COMPS', provider_info=provider_info)

    provider_info = {"endpoint": "https://comps-dev.idmod.org", "environment": "Bayesian"}
    kwargs = {'type': 'MI', 'provider': 'COMPS', 'provider_info': provider_info}
    ObjectInfoSvc.create_item(**kwargs)


def test_get_item_info():
    id = 1
    item = ObjectInfoSvc.get_item_info(id)
    print(item)


def test_get_item():
    id = 2
    item = ObjectInfoSvc.get_item(id)
    print(type(item.provider_info))
    print(item)


def test_workitem():

    item_id = "dd101772-c9b2-e811-80c9-f0921c167864"

    # check status
    state = StatusSvc.get_status(item_id)
    print(state)

    # check item info
    details = StatusSvc.get_details(item_id)
    print(details)

    wi = WorkItemSvc.get_item(item_id)
    if wi.state == WorkItemState.Created:
        wi.commission()

        # WorkItemManager.wait_for_finish(True)

        timeout = 3600
        states = [WorkItemState.Succeeded, WorkItemState.Failed, WorkItemState.Canceled]

        start = time.clock()
        state = StatusSvc.get_status(item_id)
        while state not in states and time.clock() - start < timeout:
            time.sleep(5)
            state = StatusSvc.get_status(item_id)
            print('State -> {} '.format(state.name))


def test_work_order():
    kwargs = {"A": "a", "B": "b"}
    wo = WorkOrder(**kwargs)

    wo.add_wo("Test", 10)

    print(wo.__dict__)

    print(wo.wo_2_dict())


if __name__ == "__main__":
    # test_create_item()
    # exit()

    test_get_item()
    exit()
    #
    # test_get_item_info()
    # exit()

    # test_status()
    # exit()

    test_status_2()
    exit()

    test_status_3()
    exit()

    test_workitem()
    exit()

    test_work_order()
    exit()

