import os
import shutil
import tempfile


class TempBase:

    def __init__(self):
        self.cache_directory = None

    def create_temp_directory(self):
        # Create a temporary directory for the cache
        self.cache_directory = tempfile.mkdtemp()

    def __del__(self):
        if self.cache:
            self.destroy_cache()

        if self.cache_directory and os.path.exists(self.cache_directory):
            shutil.rmtree(self.cache_directory)

